var xmlHttpRequest;
var gRefreshRequest;
var gYahooSearchRequest;
var gOldValue;
var gHuntResponse;
var gLastIndex;
var gLatestItems;
var gRefreshAllReq;
var gAllPostsFileDOM = null;
var c = null;
var gUrlList;

function doGetDelicious()
{
	if( getDelIntPref("mode") == 2 )
	{
		gOldValue = document.getElementById( "category" ).value;
		performDelYahooSearch(document.getElementById( "category" ).value);
		var buttonGetDel = document.getElementById("doGetDelBtn");
		buttonGetDel.disabled = true;
		return;
	}
	if( document.getElementById( "category" ).value == gOldValue )
	{
		var numTabs = getDelIntPref("numTabs");

		var numOpen = 0;
		var i = gLastIndex;
		while( numOpen < numTabs && i < gUrlList.length )
		{
			if( getDelBoolPref("noDisplayMine") == true && getDelIntPref( "mode" ) != 1 )
			{	//if the URL is in our posts, go to the next
				if( checkForURLInPosts( gUrlList[i] ) == true )
				{
					i++;
					continue;
				}
			}
			//if the URL is NOT in our marked as read, show it
			if( checkForUrlInRead( gUrlList[i] ) == false )
			{
				document.getElementById( "content" ).addTab( gUrlList[i] );
				numOpen++;
			}	
			i++;
		}

		gLastIndex += i;
	}
	else
	{
		gLastIndex = 0;
		xmlHttpRequest = new XMLHttpRequest();
		xmlHttpRequest.onreadystatechange = readResponse;
		gOldValue = document.getElementById( "category" ).value;
		var linkDel;
		if( getDelIntPref("mode") == 1 )
		{
			linkDel = "http://del.icio.us/rss/" + getDelCharPref("username") + "/";
		}
		else
		{
			linkDel = "http://del.icio.us/rss/tag/";
		}
		linkDel += gOldValue.replace(/\s/g, "+");
		xmlHttpRequest.open( "GET", linkDel );
		var buttonGetDel = document.getElementById("doGetDelBtn");
		buttonGetDel.disabled = true;
		xmlHttpRequest.send(null);
	}
}

function addURLToArray( theArray, subThing )
{
	if( getDelBoolPref("noDisplayMine") == true && getDelIntPref( "mode" ) != 1 )
	{
		//if we've already got this URL bookmarked, bail.
		if( checkForURLInPosts( subThing ) == true )
		{
			return;
		}
	}
	addToUniqueArray( theArray, subThing );
}
function checkForUrlInRead( url )
{
	try {
	readPostsFileDOM = document.implementation.createDocument("","doc",null);
	readPostsFileDOM.async=false;
	var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("UChrm",Components.interfaces.nsIFile);
	file.append("readposts.xml");
	if( file.exists() == false ) { return false; }
	var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var uri = ioService.newFileURI(file);
	readPostsFileDOM.load(uri.spec);
	return evaluateXPath( readPostsFileDOM.firstChild, "/readPosts/post[@href='" + url + "']" );
	}
	catch( e )
	{
		alert( e );
		return false;
	}
}

function checkForURLInPosts( url )
{
	try {
	if( gAllPostsFileDOM == null ) //if we haven't loaded it yet, load it from the file
	{
		gAllPostsFileDOM = document.implementation.createDocument("","doc",null);
		gAllPostsFileDOM.async=false;
		var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("UChrm",Components.interfaces.nsIFile);
		file.append("currentPosted.xml");
		var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var uri = ioService.newFileURI(file);
		gAllPostsFileDOM.load(uri.spec);
	}
	return evaluateXPath( gAllPostsFileDOM.firstChild, "/posts/post[@href='" + url + "']" );
	}
	catch( e )
	{
		alert( e );
		return false;
	}

}

function evaluateXPath(aNode, aExpr) 
{
	var xpe = new XPathEvaluator();
	var result = xpe.evaluate(aExpr, aNode, xpe.createNSResolver(aNode.ownerDocument.documentElement), 0, null);
	var found = [];
	while (res = result.iterateNext())
	{
		found.push(res);
		return true;
	}
	return false;
}

function doPost()
{
	var currentURI = gBrowser.currentURI.spec;
	var user = getDelCharPref("username");
	var postURI = "http://del.icio.us/" + user + "?v=2&url=" + encodeURIComponent( currentURI );
	postURI += "&title=" + encodeURIComponent( gBrowser.contentTitle );
	var contentArea=document.getElementById("appcontent");
	contentArea.addEventListener("load",postingDeliciousLoad,true);	
	gBrowser.loadURI( postURI );
}

function postingDeliciousLoad(aEvent)
{
	var doc = aEvent.originalTarget;
	var delBox = document.getElementById("category");
	doc.documentElement.getElementsByTagName("input").namedItem("tags").value = delBox.value;
	var contentArea=document.getElementById("appcontent");
	contentArea.removeEventListener("load", postingDeliciousLoad, true );
}

function doPopular()
{
	var comDel = document.getElementById( "commonDel" );
	var delBox = document.getElementById( "category" );
	delBox.value = comDel.value;
	doGetDelicious();
}

function doDeliciousRefresh()
{
	var buttonRefresh = document.getElementById("refresh");
	buttonRefresh.disabled = true;
	gRefreshRequest = new XMLHttpRequest();
	gRefreshRequest.onreadystatechange = readRefreshResponse;
	var strGet = "http://del.icio.us/rss";
	if( getDelIntPref("mode") == 1 )
	{
		strGet += "/" + getDelCharPref("username") + "/";
	}
	gRefreshRequest.open( "GET", strGet );
	gRefreshRequest.send(null);
}

function doDeliciousOptions()
{
	gOldValue = "";
	window.openDialog("chrome://huntandgather/content/optionsGetDelicious.xul","showmore",
                  "chrome" );
}

function optionsDone()
{
	var huntBox;
	var popBox;
	try {
	huntBox = opener.document.getElementById( "category" );
	popBox = opener.document.getElementById( "commonDel" );
	if( huntBox == null )
	{
		//hackish way to deal with loaded from 'extensions' dialog...
		huntBox = opener.opener.document.getElementById( "category" );
		popBox = opener.opener.document.getElementById( "commonDel" );
	}

	var mode = getDelIntPref("mode");
	if( mode == 1 )
	{
		huntBox.setAttribute( "style", "-moz-appearance:none;background-color:#CCFFCC;" );
		popBox.setAttribute( "style", "-moz-appearance:none;background-color:#CCFFCC;" );
	}
	else if( mode == 2 )
	{
		huntBox.setAttribute( "style", "-moz-appearance:none;background-color:#CCFFFF;" );
		popBox.setAttribute( "style", "-moz-appearance:none;background-color:#CCFFFF;" );
	}
	else
	{
		huntBox.setAttribute( "style", "-moz-appearance:none;background-color:white;" );
		popBox.setAttribute( "style", "-moz-appearance:none;background-color:white;" );
	}
	
	}
	catch( e )
	{
		alert( "Failed to set background to preference" );
	}
	
	return true;
}

function initToolbar(aEvent)
{
	var huntBox = document.getElementById( "category" );
	var pop = document.getElementById( "commonDel" );

	var mode = getDelIntPref("mode");
	if( mode == 1 )
	{
		huntBox.setAttribute( "style", "-moz-appearance:none;background-color:#CCFFCC;" );
		pop.setAttribute( "style", "-moz-appearance:none;background-color:#CCFFCC;" );
	}
	else if( mode == 2 )
	{
		huntBox.setAttribute( "style", "-moz-appearance:none;background-color:#CCFFFF;" );
		pop.setAttribute( "style", "-moz-appearance:none;background-color:#CCFFFF;" );
	}
	else
	{
		huntBox.setAttribute( "style", "-moz-appearance:none;background-color:white;" );
		pop.setAttribute( "style", "-moz-appearance:none;background-color:white;" );
	}

  	window.removeEventListener("load", initToolbar, true );
}

function addToUniqueArray( theArray, subThing )
{
	var found = false;
	if( theArray.length == 0 )
	{
		theArray[0] = subThing;
		return;
	}
	for( k = 0; k < theArray.length; k++ )
	{
		if( theArray[k] == subThing )
		{
			found = true;
			break;
		}
	}
	if( found != true )
	{
		theArray[theArray.length] = subThing;
	}
	
}

function readResponse()
{	
	try {
	if( xmlHttpRequest.readyState == 4 )
	{
		var delBox = document.getElementById( "category" );
		delBox.value = gOldValue;
		gHuntReponse = xmlHttpRequest.responseXML;
		var items = gHuntReponse.getElementsByTagName( "item" );
		if( items.length == 0 )
		{
			throw "No results returned.";
		}
		gLatestItems = items; //set the global variable (used for "go to user", etc.)
		
		gUrlList = new Array();
		for( q = 0; q < items.length; q++ )
		{
			addToUniqueArray( gUrlList, items[q].getElementsByTagName( "link" )[0].firstChild.nodeValue );
		}
		var numTabs = getDelIntPref("numTabs");
		if( numTabs > gUrlList.length )
		{
			numTabs = gUrlList.length;
		}
		var numOpen = 0;
		var i = 0;
		while( numOpen < numTabs && i < gUrlList.length )
		{
			if( getDelBoolPref("noDisplayMine") == true && getDelIntPref( "mode" ) != 1 )
			{	//if the URL is in our posts, go to the next
				if( checkForURLInPosts( gUrlList[i] ) == true )
				{
					i++;
					continue;
				}
			}
			//if the URL is NOT in our marked as read, show it
			if( checkForUrlInRead( gUrlList[i] ) == false )
			{
				document.getElementById( "content" ).addTab( gUrlList[i] );
				numOpen++;
			}	
			i++;
		}
		

		gLastIndex += i;
		var buttonGetDel = document.getElementById("doGetDelBtn");
		buttonGetDel.disabled = false;
	}
	else
	{
		var delBox = document.getElementById( "category" );
		delBox.value = "Working...";
	}
	}
	catch( e )
	{
		alert( "Failed to get response. " + e );
		var buttonGetDel = document.getElementById("doGetDelBtn");
		buttonGetDel.disabled = false;		
	}
}

function readRefreshResponse()
{
	if( gRefreshRequest.readyState == 4 )
	{
		var arrayList;
		try {
		var content = gRefreshRequest.responseXML;
		var items = content.getElementsByTagNameNS( "http://www.w3.org/1999/02/22-rdf-syntax-ns#", "Bag" );
		arrayList = new Array();

		var doWholeTag = getDelBoolPref("showPhrases");
		var catsToGet;
		if( items.length == 0 && getDelIntPref("mode") == 1 )
		{
			alert( "Nothing returned.  Make sure username/password set correctly" );
			var buttonRefresh = document.getElementById("refresh");
			buttonRefresh.disabled = false;
			return;
		}
		for( i = 0; i < items.length; i++ )
		{
			var subItems = items[i].getElementsByTagNameNS( "http://www.w3.org/1999/02/22-rdf-syntax-ns#", "li" );
			if( doWholeTag == true )
			{
				var totalTag;
				var maxTags = getDelIntPref("maxTags");
				if( maxTags == 0 || getDelIntPref("mode") == 1) { maxTags = 100; }
				if( subItems.length > maxTags )
				{
					continue;
				}
				for( j = 0; j < subItems.length; j++ )
				{
					var thing = subItems[j].getAttribute( "resource" );
					var subThing = thing.substring( thing.indexOf("tag") + 4 );
					if( j != 0 )
					{
						totalTag += " " + subThing;
					}
					else
					{
						totalTag = subThing;
					}
				}
				addToUniqueArray( arrayList, totalTag );
			}
			else
			{
				for( j = 0; j < subItems.length; j++ )
				{
					var thing = subItems[j].getAttribute( "resource" );
					var subThing = thing.substring( thing.indexOf("tag") + 4 );
					addToUniqueArray( arrayList, subThing );
				}
			}
		}
		}
		catch(e) { 
			var buttonRefresh = document.getElementById("refresh");
			buttonRefresh.disabled = false;
			alert( "Trouble getting values from del.icio.us" + e );
			return;
		}

		var comDel = document.getElementById( "commonDel" );
		comDel.removeAllItems();
		arrayList.sort();
		for( i = 0; i < arrayList.length; i++ )
		{
			comDel.appendItem( arrayList[i], arrayList[i] );
		}
		var pop = comDel.menupopup;
		pop.setAttribute( "style", "max-height:300px;width:300px;" );
		var buttonRefresh = document.getElementById("refresh");
		buttonRefresh.disabled = false;

	}

}


function doUpdatePosts()
{
	if( checkForUpdate() == false )
	{	//we're up to date
		alert( "No update needed" );
		return;
	}
	gRefreshAllReq = new XMLHttpRequest();
	var username = getDelCharPref("username");
	var password = getDelCharPref("password");
	gRefreshAllReq.open( "GET", "http://del.icio.us/api/posts/all", false, username, password ); //asynch is false
	gRefreshAllReq.send(null);
	if( gRefreshAllReq.status == 200 )
	{	
		// get chrome directory
		var file = Components.classes["@mozilla.org/file/directory_service;1"].
			getService(Components.interfaces.nsIProperties).
			get("UChrm", Components.interfaces.nsIFile);
		file.append( "currentPosted.xml" );
		var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		// use 0x02 | 0x10 to open file for appending.
		foStream.init(file, 0x02 | 0x08, 0664, 0); // write, create, truncate
		var serializer = new XMLSerializer();
		serializer.serializeToStream( gRefreshAllReq.responseXML, foStream, "UTF-8" );
		gAllPostsFileDOM = gRefreshAllReq.responseXML;
		foStream.close();
	}
	alert( "Update finished." );
}

function performDelYahooSearch(searchString)
{
	try {
	gYahooSearchRequest = new XMLHttpRequest();
	gYahooSearchRequest.onreadystatechange = readDelSearchResponse;
	var searchURL = "http://api.search.yahoo.com/WebSearchService/V1/webSearch?";
	searchURL += "appid=huntandgather&query=" + searchString;
	searchURL += "&results=50";
	gYahooSearchRequest.open( "GET", searchURL );
	gYahooSearchRequest.send(null);
	}
	catch( e )
	{
		alert( "Problem!" );
	}
}

function readDelSearchResponse()
{
	if( gYahooSearchRequest.readyState == 4 )
	{
		var urlsArray = new Array();
		var response = gYahooSearchRequest.responseXML;
		var clicks = response.getElementsByTagName( "ClickUrl" );
		var tempUrls = response.getElementsByTagName( "Result" );
		var responseItems = new Array(tempUrls.length);
		for( y = 0; y < tempUrls.length; y++ )
		{
			responseItems[y] = tempUrls[y].getElementsByTagName("Url")[0];
		}
		var urlsArray = new Array();
		var j = 0;
		for( i = 0; i < responseItems.length; i++ )
		{
			if( checkForURLInPosts( responseItems[i].firstChild.nodeValue ) == true )
			{
				urlsArray[j++] = clicks[i].firstChild.nodeValue;
			}
		}
		for( k = 0; k < urlsArray.length; k++ )
		{
			document.getElementById( "content" ).addTab( urlsArray[k] );			
		}
		var buttonGetDel = document.getElementById("doGetDelBtn");
		buttonGetDel.disabled = false;
		document.getElementById( "category" ).value = gOldValue;
	}
	else
	{
		var delBox = document.getElementById( "category" );
		delBox.value = "Working...";
	}
}

function checkForUpdate()
{
	//get the date in our document
	try {
	var lastUpdateFromFile = getUpdateDateFromFile();
	//get the date from the Del.icio.us service
	var lastUpdateFromDelicious = getUpdateDateFromService();
	}
	catch( e )
	{
		alert( "Failed to check if update needed. " + e );
		return false; //err on side of caution
	}
	if( lastUpdateFromDelicious.valueOf() > lastUpdateFromFile.valueOf() )
	{
		alert( "Update needed" );
		return true;		
	}
	return false;
}

function getUpdateDateFromFile()
{
	var xmlDoc = document.implementation.createDocument("","doc",null);
	xmlDoc.async=false;
	var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("UChrm",Components.interfaces.nsIFile);
	file.append("currentPosted.xml");
	if( file.exists() == false ) { return new Date( 1971, 2, 1 ); }
	var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var uri = ioService.newFileURI(file);
	xmlDoc.load(uri.spec);
	var x = xmlDoc.getElementsByTagName("posts"); //ugliness...
	return createDateFromString( x[0].attributes[0].value );
}

function getUpdateDateFromService()
{
	getUpdateDate = new XMLHttpRequest();
	var username = getDelCharPref("username");
	var password = getDelCharPref("password");
	getUpdateDate.open( "GET", "http://del.icio.us/api/posts/update", false, username, password ); //asynch is false
	getUpdateDate.send(null);
	if( getUpdateDate.status == 200 )
	{	
		var dateUpdateWithAll = getUpdateDate.responseText.split( "time=\"" );
		var fullDate = dateUpdateWithAll[1].split("\"");
		return createDateFromString( fullDate[0] );
	}
	
	return null;
}

function createDateFromString( dateStr )
{
	//man this is ugly stuff... is there a better way?  Bigger fish to fry.
	var pieces = dateStr.split("-");
	var day = pieces[2].split("T");
	var hourMinSec = day[1].split(":");
	//forget about seconds
	return new Date( pieces[0], pieces[1], day[0], hourMinSec[0], hourMinSec[1], "0" );
}
